"use strict";
/**
 * This file was auto-generated by Fern from our API Definition.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Blocks = void 0;
const environments = __importStar(require("../../../../environments"));
const core = __importStar(require("../../../../core"));
const DoptApi = __importStar(require("../../.."));
const url_search_params_1 = __importDefault(require("@ungap/url-search-params"));
const url_join_1 = __importDefault(require("url-join"));
const serializers = __importStar(require("../../../../serialization"));
const errors = __importStar(require("../../../../errors"));
class Blocks {
    constructor(options) {
        this.options = options;
    }
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     */
    getBlock(uid, request) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const { version, userIdentifier } = request;
            const _queryParams = new url_search_params_1.default();
            _queryParams.append("version", version.toString());
            _queryParams.append("userIdentifier", userIdentifier);
            const _response = yield core.fetcher({
                url: (0, url_join_1.default)((_a = (yield core.Supplier.get(this.options.environment))) !== null && _a !== void 0 ? _a : environments.DoptApiEnvironment.Default, `v2/block/${uid}`),
                method: "GET",
                headers: {
                    "X-Api-Key": yield core.Supplier.get(this.options.apiKey),
                    "X-Fern-Language": "JavaScript",
                },
                contentType: "application/json",
                queryParameters: _queryParams,
                timeoutMs: 60000,
            });
            if (_response.ok) {
                return yield serializers.GetBlockResponse.parseOrThrow(_response.body, {
                    unrecognizedObjectKeys: "passthrough",
                    allowUnrecognizedUnionMembers: true,
                    allowUnrecognizedEnumValues: true,
                    breadcrumbsPrefix: ["response"],
                });
            }
            if (_response.error.reason === "status-code") {
                switch (_response.error.statusCode) {
                    case 400:
                        throw new DoptApi.BadRequestError(_response.error.body);
                    case 401:
                        throw new DoptApi.UnauthorizedError(_response.error.body);
                    case 404:
                        throw new DoptApi.NotFoundError(_response.error.body);
                    case 500:
                        throw new DoptApi.InternalServerError(_response.error.body);
                    default:
                        throw new errors.DoptApiError({
                            statusCode: _response.error.statusCode,
                            body: _response.error.body,
                        });
                }
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.DoptApiError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.DoptApiTimeoutError();
                case "unknown":
                    throw new errors.DoptApiError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     */
    transition(uid, request) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const { transitions, version, userIdentifier, groupIdentifier } = request, _body = __rest(request, ["transitions", "version", "userIdentifier", "groupIdentifier"]);
            const _queryParams = new url_search_params_1.default();
            if (transitions != null) {
                if (Array.isArray(transitions)) {
                    for (const _item of transitions) {
                        _queryParams.append("transitions", _item);
                    }
                }
                else {
                    _queryParams.append("transitions", transitions);
                }
            }
            _queryParams.append("version", version.toString());
            _queryParams.append("userIdentifier", userIdentifier);
            if (groupIdentifier != null) {
                _queryParams.append("groupIdentifier", groupIdentifier);
            }
            const _response = yield core.fetcher({
                url: (0, url_join_1.default)((_a = (yield core.Supplier.get(this.options.environment))) !== null && _a !== void 0 ? _a : environments.DoptApiEnvironment.Default, `v2/block/${uid}/transition`),
                method: "POST",
                headers: {
                    "X-Api-Key": yield core.Supplier.get(this.options.apiKey),
                    "X-Fern-Language": "JavaScript",
                },
                contentType: "application/json",
                queryParameters: _queryParams,
                body: yield serializers.TransitionRequest.jsonOrThrow(_body, { unrecognizedObjectKeys: "strip" }),
                timeoutMs: 60000,
            });
            if (_response.ok) {
                return;
            }
            if (_response.error.reason === "status-code") {
                switch (_response.error.statusCode) {
                    case 400:
                        throw new DoptApi.BadRequestError(_response.error.body);
                    case 401:
                        throw new DoptApi.UnauthorizedError(_response.error.body);
                    case 404:
                        throw new DoptApi.NotFoundError(_response.error.body);
                    case 500:
                        throw new DoptApi.InternalServerError(_response.error.body);
                    default:
                        throw new errors.DoptApiError({
                            statusCode: _response.error.statusCode,
                            body: _response.error.body,
                        });
                }
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.DoptApiError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.DoptApiTimeoutError();
                case "unknown":
                    throw new errors.DoptApiError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
}
exports.Blocks = Blocks;
