/**
 * This file was auto-generated by Fern from our API Definition.
 */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import * as environments from "../../../../environments";
import * as core from "../../../../core";
import * as DoptApi from "../../..";
import { default as URLSearchParams } from "@ungap/url-search-params";
import urlJoin from "url-join";
import * as serializers from "../../../../serialization";
import * as errors from "../../../../errors";
export class Flows {
    constructor(options) {
        this.options = options;
    }
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     */
    getFlow(sid, request) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const { version, include, userIdentifier, groupIdentifier } = request;
            const _queryParams = new URLSearchParams();
            _queryParams.append("version", version.toString());
            if (include != null) {
                _queryParams.append("include", include);
            }
            _queryParams.append("userIdentifier", userIdentifier);
            if (groupIdentifier != null) {
                _queryParams.append("groupIdentifier", groupIdentifier);
            }
            const _response = yield core.fetcher({
                url: urlJoin((_a = (yield core.Supplier.get(this.options.environment))) !== null && _a !== void 0 ? _a : environments.DoptApiEnvironment.Default, `v2/flow/${sid}`),
                method: "GET",
                headers: {
                    "X-Api-Key": yield core.Supplier.get(this.options.apiKey),
                    "X-Fern-Language": "JavaScript",
                },
                contentType: "application/json",
                queryParameters: _queryParams,
                timeoutMs: 60000,
            });
            if (_response.ok) {
                return yield serializers.GetFlowResponse.parseOrThrow(_response.body, {
                    unrecognizedObjectKeys: "passthrough",
                    allowUnrecognizedUnionMembers: true,
                    allowUnrecognizedEnumValues: true,
                    breadcrumbsPrefix: ["response"],
                });
            }
            if (_response.error.reason === "status-code") {
                switch (_response.error.statusCode) {
                    case 400:
                        throw new DoptApi.BadRequestError(_response.error.body);
                    case 401:
                        throw new DoptApi.UnauthorizedError(_response.error.body);
                    case 404:
                        throw new DoptApi.NotFoundError(_response.error.body);
                    case 500:
                        throw new DoptApi.InternalServerError(_response.error.body);
                    default:
                        throw new errors.DoptApiError({
                            statusCode: _response.error.statusCode,
                            body: _response.error.body,
                        });
                }
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.DoptApiError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.DoptApiTimeoutError();
                case "unknown":
                    throw new errors.DoptApiError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
    /**
     * @throws {@link DoptApi.BadRequestError}
     * @throws {@link DoptApi.UnauthorizedError}
     * @throws {@link DoptApi.NotFoundError}
     * @throws {@link DoptApi.InternalServerError}
     */
    intent(uid, intent, request) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            const { version, userIdentifier, groupIdentifier } = request, _body = __rest(request, ["version", "userIdentifier", "groupIdentifier"]);
            const _queryParams = new URLSearchParams();
            _queryParams.append("version", version.toString());
            _queryParams.append("userIdentifier", userIdentifier);
            if (groupIdentifier != null) {
                _queryParams.append("groupIdentifier", groupIdentifier);
            }
            const _response = yield core.fetcher({
                url: urlJoin((_a = (yield core.Supplier.get(this.options.environment))) !== null && _a !== void 0 ? _a : environments.DoptApiEnvironment.Default, `v2/flow/${uid}/${yield serializers.IntentRequestIntent.jsonOrThrow(intent)}`),
                method: "POST",
                headers: {
                    "X-Api-Key": yield core.Supplier.get(this.options.apiKey),
                    "X-Fern-Language": "JavaScript",
                },
                contentType: "application/json",
                queryParameters: _queryParams,
                body: yield serializers.IntentRequest.jsonOrThrow(_body, { unrecognizedObjectKeys: "strip" }),
                timeoutMs: 60000,
            });
            if (_response.ok) {
                return;
            }
            if (_response.error.reason === "status-code") {
                switch (_response.error.statusCode) {
                    case 400:
                        throw new DoptApi.BadRequestError(_response.error.body);
                    case 401:
                        throw new DoptApi.UnauthorizedError(_response.error.body);
                    case 404:
                        throw new DoptApi.NotFoundError(_response.error.body);
                    case 500:
                        throw new DoptApi.InternalServerError(_response.error.body);
                    default:
                        throw new errors.DoptApiError({
                            statusCode: _response.error.statusCode,
                            body: _response.error.body,
                        });
                }
            }
            switch (_response.error.reason) {
                case "non-json":
                    throw new errors.DoptApiError({
                        statusCode: _response.error.statusCode,
                        body: _response.error.rawBody,
                    });
                case "timeout":
                    throw new errors.DoptApiTimeoutError();
                case "unknown":
                    throw new errors.DoptApiError({
                        message: _response.error.errorMessage,
                    });
            }
        });
    }
}
